version: "3"

volumes:
  local_postgres_data: {}
  local_postgres_data_backups: {}
  notebooks: {}
  src:
    driver: local
  prodigy_data:
    driver: local
  models:
    driver: local
  annotations:
    driver: local
  es_data: {}
  media:
    driver: local
services:
  web:
    build:
      context: .
      dockerfile: compose/production/django_u/Dockerfile
    container_name: dz01
    depends_on:
      - db
    volumes:
      - src:/src/
      - models:/app/models/
      - annotations:/app/annotations/
      - notebooks:/app/notebooks/
      - prodigy_data:/app/prodigy/
    expose:
      - 8000
    links:
      - redis
    env_file:
      - ./.envs/.django.production
    environment:
      - PRODIGY_HOST=0.0.0.0
      - PRODIGY_HOME=/app/prodigy/
  prodigy_de:
    image: app_web:latest
    container_name: p01de
    depends_on:
      - web
      - db
      - elasticsearch
    volumes:
      - src:/src
      - models:/app/models/
      - annotations:/app/annotations/
      - notebooks:/app/notebooks/
      - prodigy_data:/app/prodigy/
    expose:
      - 8881
    links:
      - redis
    env_file:
      - ./.envs/.django
    environment: 
      - PRODIGY_PORT=8881 
      - PRODIGY_HOST=0.0.0.0
      - PRODIGY_HOME=/app/prodigy/
    command: prodigy ner.correct de_gold de_core_news_md /app/annotations/de.jsonl --label PER,LOC,ORG,GEO_TERM
    # command: prodigy ner.correct gold_de /app/models/de /app/src/media/jsonl/de.jsonl --label PER,LOC,ORG,GEO_TERM
    # command: prodigy ner.correct clean_mte en_core_web_lg ./media/jsonl/find_terms.jsonl --label PER,LOC,ORG,GEO_TERM
    # command: prodigy review reviewed_final mte_2,mte --view-id ner_manual --label PER,LOC,ORG,GEO_TERM
  prodigy_fr:
    image: app_web:latest
    container_name: p01fr
    depends_on:
      - web
      - db
      - elasticsearch
    volumes:
      - src:/src
      - models:/app/models/
      - annotations:/app/annotations/
      - notebooks:/app/notebooks/
      - prodigy_data:/app/prodigy/
    expose:
      - 8882
    links:
      - redis
    env_file:
      - ./.envs/.django
    environment: 
      - PRODIGY_PORT=8882
      - PRODIGY_HOST=0.0.0.0
      - PRODIGY_HOME=/app/prodigy/
    command: prodigy ner.correct fr_gold fr_core_news_md /app/annotations/fr.jsonl --label PER,LOC,ORG,GEO_TERM
    # command: prodigy ner.correct gold_fr /app/models/fr /app/src/media/jsonl/fr.jsonl --label PER,LOC,ORG,GEO_TERM
    # command: prodigy ner.correct clean_mte en_core_web_lg ./media/jsonl/find_terms.jsonl --label PER,LOC,ORG,GEO_TERM
    # command: prodigy review reviewed_final mte_2,mte --view-id ner_manual --label PER,LOC,ORG,GEO_TERM
  prodigy_it:
    image: app_web:latest
    container_name: p01it
    depends_on:
      - web
      - db
      - elasticsearch
    volumes:
      - src:/src
      - models:/app/models/
      - annotations:/app/annotations/
      - notebooks:/app/notebooks/
      - prodigy_data:/app/prodigy/
    expose:
      - 8883
    links:
      - redis
    env_file:
      - ./.envs/.django
    environment: 
      - PRODIGY_PORT=8883
      - PRODIGY_HOST=0.0.0.0
      - PRODIGY_HOME=/app/prodigy
    command: prodigy ner.correct it_gold it_core_news_sm /app/annotations/it.jsonl --label PER,LOC,ORG,GEO_TERM
    # command: prodigy ner.correct gold_it /app/models/it /app/src/media/jsonl/it.jsonl --label PER,LOC,ORG,GEO_TERM
    # command: prodigy ner.correct clean_mte en_core_web_lg ./media/jsonl/find_terms.jsonl --label PER,LOC,ORG,GEO_TERM
    # command: prodigy review reviewed_final mte_2,mte --view-id ner_manual --label PER,LOC,ORG,GEO_TERM
  prodigy_en:
    image: app_web:latest
    container_name: p01en
    depends_on:
      - web
      - db
      - elasticsearch
    volumes:
      - src:/src
      - models:/app/models/
      - annotations:/app/annotations/
      - notebooks:/app/notebooks/
      - prodigy_data:/app/prodigy/
    expose:
      - 8884
    links:
      - redis
    env_file:
      - ./.envs/.django
    environment: 
      - PRODIGY_PORT=8884
      - PRODIGY_HOST=0.0.0.0
      - PRODIGY_HOME=/app/prodigy
    command: prodigy ner.correct en_gold en_core_web_lg /app/annotations/en.jsonl --label PERSON,ORG,GPE,LOC,GEO_TERM
    # command: prodigy ner.correct gold_en /app/models/en /app/src/media/jsonl/en.jsonl --label PERSON,ORG,GPE,LOC,GEO_TERM
    # command: prodigy ner.correct clean_mte en_core_web_lg ./media/jsonl/find_terms.jsonl --label PERSON,ORG,GPE,LOC,GEO_TERM
    # command: prodigy review reviewed_final mte_2,mte --view-id ner_manual --label PERSON,ORG,GPE,LOC,GEO_TERM

  jupyter:
    image: app_web:latest
    container_name: jp01
    depends_on:
      - db
    volumes:
      - src:/src/
      - models:/app/models/
      - annotations:/app/annotations/
      - notebooks:/app/notebooks/
      - prodigy_data:/app/prodigy/
    expose:
      - 4444
    links:
      - redis
    env_file:
      - ./.envs/.django.production
    environment: 
      - DJANGO_ALLOW_ASYNC_UNSAFE='true'
    command: python manage.py shell_plus --notebook
  elasticsearch:
    image: docker.elastic.co/elasticsearch/elasticsearch:7.5.0
    container_name: es01
    environment:
      - discovery.type=single-node
    volumes:
      - es_data:/usr/share/elasticsearch/data
    ports:
      - 9200:9200
  nginx:
    build:
      context: . 
      dockerfile: compose/production/nginx/Dockerfile
    container_name: nz01
    ports:
      - "80:80"
      - "443:443"
      - "8888:8888"
      - "8881:8881"
      - "8882:8882"
      - "8883:8883"
      - "8884:8884"
      - "4444:4444"
    depends_on:
      - web
      - prodigy_de
      - prodigy_fr
      - prodigy_it
      - prodigy_en
      - jupyter
  db:
    build:
      context: .
      dockerfile: compose/postgres/Dockerfile
    container_name: pz01
    env_file:
      - ./.envs/.postgres
    volumes:
      - local_postgres_data:/var/lib/postgresql/data
      - local_postgres_data_backups:/backups
  redis:
    image: redis:alpine
    container_name: rz01
    ports:
      - "6379:6379"
